<template>
  <b-container fluid>
    <b-row class="justify-content-md-center">
      <b-col cols="12" md="9">
        <div ref="map-root" class="map">
          <p ref="point-coordinate" class="markercoordinate" />
          <UsefulTools
            class="tools_position"
            @measurementType="measurementType"
            @drawType="drawType"
          />
          <ShowMeasurements
            v-if="measurement_value !== ''"
            class="measurementContainer"
            :measurementValue="measurement_value"
            :shapeType="shape_type"
/>
          <div class="divListContainer" v-if="selectedLayers.length > 0">
            <b-card no-body class="mb-1 text-center bg-secondary">
              <b-card-header header-tag="header" class="p-1" role="tab">
                <b-card-text class="selectedLayerHeader">
                  {{ $t("message.selected_layer_haeder") }}
                </b-card-text>
              </b-card-header>
            </b-card>
            <selectedLayer
              v-for="selectedLayer in selectedLayers"
              :key="selectedLayer.id"
              :selectedLayer="selectedLayer"
              :removeLayerFromList="removeLayerFromList"
              :removeLayerFromListToSend="removeLayerFromListToSend"
            />
          </div>
        </div>
      </b-col>
      <b-col cols="5" md="3" class="p-3 bg-secondary">
        <Header />
        <!-- <Profile /> -->
        <Layer
          v-for="layer in infoLayers"
          :key="layer.id"
          :layer="layer"
          :selectedLayers="selectedLayers"
          :addLayerToSelectedLayers="addLayerToSelectedLayers"
        />
        <Footer />
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import View from "ol/View";
import Map from "ol/Map";
// import TileLayer from "ol/layer/Tile";
import { Image as ImageLayer, Tile as TileLayer } from "ol/layer";
import OSM from "ol/source/OSM";
import VectorLayer from "ol/layer/Vector";
import VectorSource from "ol/source/Vector";
import {
  Circle as CircleStyle,
  Fill,
  Stroke,
  Style,
  Icon,
  Text,
} from "ol/style";
import Feature from "ol/Feature";
import Point from "ol/geom/Point";
import { Draw, Modify, Snap, Select } from "ol/interaction";
import { finishDrawing } from "ol/interaction/Draw";
import { singleClick } from "ol/events/condition";
import Polygon from "ol/geom/Polygon";
import { getArea, getLength } from "ol/sphere";
import { fromLonLat, transform } from "ol/proj";
import MousePosition from "ol/control/MousePosition";
import { createStringXY } from "ol/coordinate";
import { OverviewMap, defaults as defaultControls } from "ol/control";
import Overlay from "ol/Overlay";
import { unByKey } from "ol/Observable";
import ImageWMS from "ol/source/ImageWMS";
import Header from "../components/Sidebar/Header";
import Profile from "../components/Sidebar/Profile";
import Layer from "../components/Sidebar/Layer";
import Footer from "../components/Sidebar/Footer";
import SelectedLayer from "../components/Tools/SelectedLayer";
import UsefulTools from "../components/Tools/UsefulTools";
import ShowMeasurements from "../components/MeasurementLayer/ShowMeasurements";
export default {
  name: "MapContainer",
  components: {
    Header,
    Profile,
    Layer,
    Footer,
    UsefulTools,
    ShowMeasurements,
    selectedLayer: SelectedLayer,
  },
  data() {
    return {
      map: null,
      infoLayers: [],
      selectedLayers: [],
      selectedLayersToSend: [],
      measurement_value: "",
      shape_type: "",
      draw: null,
      select_shape: null,
      modify_shape: null,
      draw_type: "",
      featureID: 0,
      source: null,
    };
  },
  beforeMount() {
    axios
      .get("https://next.json-generator.com/api/json/get/4k935kVLF")
      .then((res) => {
        this.infoLayers = res.data;
      });
  },
  mounted() {
    let mousePositionControl = this.mousePosition(),
      source = new OSM(),
      overviewMapControl = this.showOverViewMap(source);
    let map = new Map({
      controls: defaultControls().extend([
        mousePositionControl, 
        overviewMapControl,
      ]),
      target: this.$refs["map-root"],
      layers: [
        new TileLayer({
          source: source,
          // className: "ol-control",
        }),
        new ImageLayer({
          source: new ImageWMS({
            url: "http://172.16.15.99:33763/geoserver/gis/wms",
            params: {
              service: 'WMS', 
              version: '1.1.1',
              request:'GetMap',
              // fromat: 'image/PNG',
              layers: 'gis:iran',
              // transparent: true,
              width: 768,
              height: 330,
              srs: 'EPSG:4326',
              bbox: '51.99986%2C35.99986%2C60.00014%2C37.00014'
               },
               crossOrigin: null,
            ratio: 4,
            serverType: "geoserver",
          }),
        }),
      ],

      view: new View({
        zoom: 5,
        center: fromLonLat([53.688, 32.4279]),
        constrainResolution: true,
      }),
    });
    this.map = map;
    // this.getMarker(map);
  },
  methods: {
    addLayerToSelectedLayers(layer) {
      this.selectedLayers.push(layer);
      console.log(this.selectedLayers);
    },
    removeLayerFromList(layer) {
      let array = this.selectedLayers;
      let removeIndex = array
        .map(function (item) {
          return item.id;
        })
        .indexOf(layer.id);
      alert(removeIndex);
      array.splice(removeIndex, 1);
    },
    addSelectedLayerToSend(layer) {
      this.selectedLayersToSend.push(layer);
    },
    removeLayerFromListToSend(layer) {
      let array = this.selectedLayersToSend;
      let removeIndex = array
        .map(function (item) {
          return item.id;
        })
        .indexOf(layer.id);
      alert(removeIndex);
      array.splice(removeIndex, 1);
    },
    mousePosition() {
      let mousePositionControl = new MousePosition({
        coordinateFormat: createStringXY(4),
        projection: "EPSG:4326",
        className: "custom-mouse-position",
        target: this.$refs["point-coordinate"],
        undefinedHTML: "&nbsp;",
      });
      return mousePositionControl;
    },
    showOverViewMap(source) {
      let overviewMapControl = new OverviewMap({
        layers: [
          new TileLayer({
            source: source,
          }),
        ],
      });
      return overviewMapControl;
    },
    getMarker(map) {
      let self = this,
        iconStyle = new Style({
          image: new Icon({
            anchor: [0.5, 46],
            anchorXUnits: "fraction",
            anchorYUnits: "pixels",
            opacity: 0.75,
            src: "icon.png",
          }),
          text: new Text({
            font: "12px Calibri,sans-serif",
            fill: new Fill({ color: "#000" }),
            stroke: new Stroke({
              color: "#fff",
              width: 2,
            }),
            text: "",
          }),
        });
      map.on("click", function (evt) {
        // const coord = map.getCoordinateFromPixel(evt.pixel);
        // self.$refs["point-coordinate"].innerHTML = `Coordinate:${transform(
        //   [coord[0], coord[1]],
        //   "EPSG:3857",
        //   "EPSG:4326"
        // )}`;
        let vectorSource = new VectorSource(),
          vectorLayer = new VectorLayer({
            source: vectorSource,
          });

        //convert to lonLat scale with transform function
        // alert(transform(evt.coordinate, 'EPSG:3857', 'EPSG:4326'));
        let feature = new Feature(new Point(evt.coordinate));
        map.addLayer(vectorLayer);
        feature.setStyle(iconStyle);
        vectorSource.addFeature(feature);
      });
    },

    measurementType(measurement_type) {
      this.shape_type = measurement_type;
      this.source.clear()
    },
    drawType(draw_type) {
      let map = this.map,
        draw = this.draw,
        shape_type = this.shape_type,
        source = this.source;
      map.removeInteraction(draw);
      if (draw_type == "modify") {
        this.modifyShape();
        this.setActiveType(true);
      } else if (draw_type == "draw") {
        if (draw !== null && shape_type === draw.type_) {
          draw.setActive(false);
          this.setActiveType(false);
        }
        this.drawShape(map, shape_type, source);
      } else if (draw_type == "delete") {
        this.deleteShape(source);
        this.setActiveType(true);
      }
    },
    drawShape(map, type, vectorSource) {
      let draw = null,
        self = this,
        source = new VectorSource(),
        vector = new VectorLayer({
          source: source,
          style: new Style({
            fill: new Fill({
              color: "rgba(255, 255, 255, 0.2)",
            }),
            stroke: new Stroke({
              color: "#ffcc33",
              width: 2,
            }),
            image: new CircleStyle({
              radius: 7,
              fill: new Fill({
                color: "#ffcc33",
              }),
            }),
          }),
        });
      draw = new Draw({
        source: source,
        type: type,
      });
      self.draw = draw;
      self.source = source;
      draw.on("drawend", function (evt) {
        let feature = evt.feature,
          geometry = feature.getGeometry(),
          shapeValue =
            type === "Polygon" ? getArea(geometry) : getLength(geometry),
          output = "";
        self.featureID = self.featureID + 1;
        feature.setProperties({
          id: self.featureID,
        });
        if (type === "Polygon") {
          if (shapeValue > 10000) {
            output =
              Math.round((shapeValue / 1000000) * 100) / 100 + " " + "km2";
          } else {
            output = Math.round(shapeValue * 100) / 100 + " " + "m2";
          }
        } else {
          if (shapeValue > 100) {
            output = Math.round((shapeValue / 1000) * 100) / 100 + " " + "km";
          } else {
            output = Math.round(shapeValue * 100) / 100 + " " + "m";
          }
        }
        self.measurement_value = output;
      });
      map.addInteraction(draw);
      map.addLayer(vector);
    },
    modifyShape() {
      let map = this.map,
        self = this,
        select_shape = null,
        modify_shape = null,
        type = this.shape_type,
        output = "";
      select_shape = new Select();
      map.addInteraction(select_shape);
      modify_shape = new Modify({
        features: select_shape.getFeatures(),
      });
      this.select_shape = select_shape;
      this.modify_shape = modify_shape;
      map.addInteraction(modify_shape);
      modify_shape.on("modifyend", function (evt) {
        let feature = evt.target.features_.array_[0];
        let geometry = feature.getGeometry(),
          shapeValue =
            type === "Polygon" ? getArea(geometry) : getLength(geometry);
        if (type === "Polygon") {
          if (shapeValue > 10000) {
            output =
              Math.round((shapeValue / 1000000) * 100) / 100 + " " + "km2";
          } else {
            output = Math.round(shapeValue * 100) / 100 + " " + "m2";
          }
        } else {
          if (shapeValue > 100) {
            output = Math.round((shapeValue / 1000) * 100) / 100 + " " + "km";
          } else {
            output = Math.round(shapeValue * 100) / 100 + " " + "m";
          }
        }
        self.measurement_value = output;
      });
      // this.modifySetEvents();
    },
    modifySetEvents() {
      let select_shape = this.select_shape;
      let selectedFeatures = select_shape.getFeatures();
      select_shape.on("change:active", function () {
        selectedFeatures.forEach(function (each) {
          selectedFeatures.remove(each);
        });
      });
    },
    setActiveType(active) {
      let select_shape = this.select_shape,
        modify_shape = this.modify_shape;
      select_shape.setActive(active);
      modify_shape.setActive(active);
    },
    deleteShape(source) {
      let map = this.map,
        // source = this.source,
        select_shape = null,
        modify_shape = null,
        selectedFeatureID = 0;
      select_shape = new Select();
      map.addInteraction(select_shape);
      modify_shape = new Modify({
        features: select_shape.getFeatures(),
      });
      this.select_shape = select_shape;
      this.modify_shape = modify_shape;
      map.addInteraction(modify_shape);
      select_shape.getFeatures().on("remove", function (event) {
        let properties = event.element.getProperties();
        selectedFeatureID = properties.id;
        let features = source.getFeatures();
        if (features != null && features.length > 0) {
          features.map((item) => {
            if (item.values_.id == selectedFeatureID) {
              return source.removeFeature(item);
            }
          });
        }
      });
    },
  },
};
</script>
<style scoped>
@import "~ol/ol.css";
.map {
  margin: 0;
  height: 600px;
  width: 100%;
}
.markercoordinate {
  position: absolute;
  bottom: 10px;
  left: 50px;
  color: #ffffff;
  background-color: #000000;
  width: 150px;
  z-index: 100;
  padding: 10px;
  border-radius: 20px;
  opacity: 0.7;
}
.areaTextStyle {
  background-color: rgba(0, 0, 0, 0.6);
  border-radius: 20px;
  padding: 10px;
  color: #ffffff;
}
.ol-control {
  width: 50px;
}
.divListContainer {
  position: absolute;
  top: 10px;
  right: 50px;
  z-index: 100;
}
.selectedLayerHeader {
  text-align: center;
  font-weight: bold;
  padding: 10px;
  color: #ffffff;
}
.tools_position {
  position: absolute;
  top: 0px;
  right: 30px;
  z-index: 100;
}
.measurementContainer {
  position: absolute;
  top: 80%;
  right: 30px;
  z-index: 100;
}
</style>